Attribute VB_Name = "ML33tChat"
Option Explicit

' Subclass
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const GWL_WNDPROC = (-4)

Private OldWndProc As Long

Private Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Const WM_GETMINMAXINFO = &H24

Private Type MinMaxInfo
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Private MinimumX As Long
Private MinimumY As Long

Public Function GetUser(Nickname As String) As CUser
    For Each GetUser In frmMain.Users
        If GetUser.Nickname = Nickname Then Exit Function
    Next
End Function

' Subclass for minimum size
Public Sub Subclass()
    MinimumX = 5000 \ Screen.TwipsPerPixelX
    MinimumY = 4920 \ Screen.TwipsPerPixelY
    OldWndProc = SetWindowLong(frmMain.hWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnSubClass()
    SetWindowLong frmMain.hWnd, GWL_WNDPROC, OldWndProc
End Sub

Public Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim MMInfo As MinMaxInfo
    If uMsg = WM_GETMINMAXINFO Then
        MemCopy MMInfo, ByVal lParam, Len(MMInfo)
        With MMInfo
            .ptMinTrackSize.x = MinimumX
            .ptMinTrackSize.y = MinimumY
        End With
        MemCopy ByVal lParam, MMInfo, Len(MMInfo)
        WindowProc = 0 ' Message Processed
    Else
        WindowProc = CallWindowProc(OldWndProc, hWnd, uMsg, wParam, ByVal lParam)
    End If
End Function
